#include <bits/stdc++.h>

using namespace std;


int main()
{
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    long long n, m;
    scanf("%lld %lld",&n,&m);
    long long a1[m];
    long long levo = 0, desno = 0;
    long long k;
    for(int i = 0;i < m;i++){
        a1[i] = 1;
    }

    long long a[n][m];
    for(int i = 0;i < n;i++){
        for(int j = 0;j < m;j++){
            scanf("%lld",&a[i][j]);
        }
    }


    for(int i = 0;i < n;i++){
        for(int j = 0;j < m;j++){
                levo = 0;
                desno = 0;
            if(a[i][j] == 0 && a1[j] != 0){

                if(j == 0){
                    while(a[i][j] == 0){
                        desno += a1[j];
                        a1[j] = 0;
                        j++;
                    }
                    a1[j] += desno;
                }else{
                    k = j - 1;
                    while(a[i][j] == 0 && j < m){
                            if(a1[j] % 2 == 0){
                                levo += a1[j] / 2;
                                desno += a1[j] / 2;
                            }else{
                                if((i + 1) % 2 == 0){
                                    desno += a1[j] / 2 + 1;
                                    levo += a1[j] / 2;
                                }else{
                                    desno += a1[j] / 2;
                                    levo += a1[j] / 2 + 1;
                                }
                            }

                            a1[j] = 0;
                        
                        j++;
                    }
                    if(j == m){
                        a1[k] += (desno + levo);
                    }else{
                        a1[k] += levo;
                        a1[j] += desno;
                    }
                }


            }
        }
        for(int i = 0;i < m;i++){
            cout << a1[i] << " ";
        }
    }
}